package org.dromara.zhishu.service;

import org.dromara.common.oss.entity.UploadResult;
import org.dromara.zhishu.domain.vo.ShopDetailVo;
import org.dromara.zhishu.domain.bo.ShopDetailBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.springframework.web.multipart.MultipartFile;

import java.util.Collection;
import java.util.List;

/**
 * 商品详情Service接口
 *
 * @author yxy
 * @date 2025-03-13
 */
public interface IShopDetailService {

    /**
     * 查询商品详情
     *
     * @param id 主键
     * @return 商品详情
     */
    ShopDetailVo queryById(Long id);

    /**
     * 查询店铺设置信息
     * @param shopId 店铺id
     * @return
     */
    ShopDetailVo queryByShopId(Long shopId);

    /**
     * 分页查询商品详情列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 商品详情分页列表
     */
    TableDataInfo<ShopDetailVo> queryPageList(ShopDetailBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的商品详情列表
     *
     * @param bo 查询条件
     * @return 商品详情列表
     */
    List<ShopDetailVo> queryList(ShopDetailBo bo);

    /**
     * 新增商品详情
     *
     * @param bo 商品详情
     * @return 是否新增成功
     */
    Boolean insertByBo(ShopDetailBo bo);

    /**
     * 修改商品详情
     *
     * @param bo 商品详情
     * @return 是否修改成功
     */
    Boolean updateByBo(ShopDetailBo bo);

    /**
     * 校验并批量删除商品详情信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    UploadResult upload(MultipartFile file);

    /**
     * 根据店铺ID获取价格模板ID
     * @param shopId 店铺ID
     * @return 价格模板ID，如果不存在返回null
     */
    String selectSaleTemplateIdByShopId(Long shopId);
}
